

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.device_cython_hidapi &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.device_cython_hidapi</h1><div class="highlight"><pre>
<span class="sd">&quot;&quot;&quot;Low level USB interface to weather station, using cython-hidapi.</span>

<span class="sd">Introduction</span>
<span class="sd">============</span>

<span class="sd">This module handles low level communication with the weather station</span>
<span class="sd">via the `cython-hidapi &lt;https://github.com/gbishop/cython-hidapi&gt;`_</span>
<span class="sd">library. An alternative module, :doc:`pywws.device_pyusb`, uses the</span>
<span class="sd">`PyUSB &lt;http://sourceforge.net/apps/trac/pyusb/&gt;`_ library. The choice</span>
<span class="sd">of which module to use depends on which libraries are available for</span>
<span class="sd">you computer.</span>

<span class="sd">Users of recent versions of Mac OS have no choice. The operating</span>
<span class="sd">system makes it very difficult to access HID devices (such as the</span>
<span class="sd">weather station) directly, so the ``hidapi`` library has to be used.</span>
<span class="sd">``cython-hidapi`` is a Python interface to that library.</span>

<span class="sd">Users of OpenWRT and similar embedded Linux platforms will probably</span>
<span class="sd">not be able to install ``cython-hidapi``, so are constrained to use</span>
<span class="sd">``libusb`` and its ``PyUSB`` Python interface.</span>

<span class="sd">Installation</span>
<span class="sd">============</span>

<span class="sd">Some of this software may already be installed on your machine, so do</span>
<span class="sd">check before downloading sources and compiling them yourself.</span>

<span class="sd">#.  Install hidapi.</span>

<span class="sd">    Create a local copy of the git repository, change to the new</span>
<span class="sd">    directory and then follow the instructions in ``README.txt``::</span>

<span class="sd">        git clone https://github.com/signal11/hidapi.git</span>
<span class="sd">        cd hidapi</span>
<span class="sd">        more README.txt</span>

<span class="sd">#.  Install cython.</span>

<span class="sd">    This should be available as a package for your operating system.</span>
<span class="sd">    For example::</span>
<span class="sd">        sudo apt-get install cython</span>

<span class="sd">#.  Install cython-hidapi.</span>

<span class="sd">    This also needs to be downloaded and built::</span>

<span class="sd">        git clone https://github.com/gbishop/cython-hidapi.git</span>
<span class="sd">        cd cython-hidapi</span>
<span class="sd">        python setup.py build</span>
<span class="sd">        sudo python setup.py install</span>

<span class="sd">    Replace ``setup.py`` with ``setup-mac.py`` or ``setup-windows.py``</span>
<span class="sd">    if you are using Mac OS or Windows.</span>

<span class="sd">Testing</span>
<span class="sd">=======</span>

<span class="sd">Run ``TestWeatherStation.py`` with increased verbosity so it reports</span>
<span class="sd">which USB device access module is being used::</span>

<span class="sd">    python TestWeatherStation.py -vv</span>
<span class="sd">    18:10:27:pywws.WeatherStation.CUSBDrive:using pywws.device_cython_hidapi</span>
<span class="sd">    0000 55 aa ff ff ff ff ff ff ff ff ff ff ff ff ff ff 05 20 01 51 11 00 00 00 81 00 00 07 01 00 d0 56</span>
<span class="sd">    0020 61 1c 61 1c 00 00 00 00 00 00 00 12 02 14 18 09 41 23 c8 00 32 80 47 2d 2c 01 2c 81 5e 01 1e 80</span>
<span class="sd">    0040 a0 00 c8 80 a0 28 80 25 a0 28 80 25 03 36 00 05 6b 00 00 0a 00 f4 01 18 00 00 00 00 00 00 00 00</span>
<span class="sd">    0060 00 00 54 1c 63 0a 2f 01 71 00 7a 01 59 80 7a 01 59 80 e4 00 f5 ff 69 54 00 00 fe ff 00 00 b3 01</span>
<span class="sd">    0080 0c 02 d0 ff d3 ff 5a 24 d2 24 dc 17 00 11 09 06 15 40 10 03 07 22 18 10 08 11 08 30 11 03 07 12</span>
<span class="sd">    00a0 36 08 07 24 17 17 11 02 28 10 10 09 06 30 14 29 12 02 11 06 57 09 06 30 14 29 12 02 11 06 57 08</span>
<span class="sd">    00c0 08 31 14 30 12 02 14 18 04 12 02 01 10 12 11 09 13 17 19 11 08 21 16 53 11 09 13 17 19 12 01 18</span>
<span class="sd">    00e0 07 17 10 02 22 11 06 11 11 06 13 12 11 11 06 13 12 11 11 10 11 38 11 11 10 11 38 10 02 22 14 43</span>

<span class="sd">API</span>
<span class="sd">===</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__docformat__</span> <span class="o">=</span> <span class="s">&quot;restructuredtext en&quot;</span>

<span class="kn">import</span> <span class="nn">hid</span>

<div class="viewcode-block" id="USBDevice"><a class="viewcode-back" href="../../api/pywws.device_cython_hidapi.html#pywws.device_cython_hidapi.USBDevice">[docs]</a><span class="k">class</span> <span class="nc">USBDevice</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idVendor</span><span class="p">,</span> <span class="n">idProduct</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Low level USB device access via cython-hidapi library.</span>

<span class="sd">        :param idVendor: the USB ``vendor ID` number, for example 0x1941.</span>

<span class="sd">        :type idVendor: int</span>

<span class="sd">        :param idProduct: the USB ``product ID` number, for example 0x8021.</span>

<span class="sd">        :type idProduct: int</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hid</span> <span class="o">=</span> <span class="n">hid</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="n">idVendor</span><span class="p">,</span> <span class="n">idProduct</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">hid</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&quot;Weather station device not found&quot;</span><span class="p">)</span>

<div class="viewcode-block" id="USBDevice.read_data"><a class="viewcode-back" href="../../api/pywws.device_cython_hidapi.html#pywws.device_cython_hidapi.USBDevice.read_data">[docs]</a>    <span class="k">def</span> <span class="nf">read_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">size</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Receive data from the device.</span>

<span class="sd">        If the read fails for any reason, an :obj:`IOError` exception</span>
<span class="sd">        is raised.</span>

<span class="sd">        :param size: the number of bytes to read.</span>

<span class="sd">        :type size: int</span>

<span class="sd">        :return: the data received.</span>

<span class="sd">        :rtype: list(int)</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">list</span><span class="p">()</span>
        <span class="k">while</span> <span class="n">size</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">count</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">size</span><span class="p">,</span> <span class="mi">8</span><span class="p">)</span>
            <span class="n">buf</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">hid</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="n">count</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">count</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&#39;pywws.device_cython_hidapi.USBDevice.read_data failed&#39;</span><span class="p">)</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="n">buf</span>
            <span class="n">size</span> <span class="o">-=</span> <span class="n">count</span>
        <span class="k">return</span> <span class="n">result</span>
</div>
<div class="viewcode-block" id="USBDevice.write_data"><a class="viewcode-back" href="../../api/pywws.device_cython_hidapi.html#pywws.device_cython_hidapi.USBDevice.write_data">[docs]</a>    <span class="k">def</span> <span class="nf">write_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">buf</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Send data to the device.</span>

<span class="sd">        :param buf: the data to send.</span>

<span class="sd">        :type buf: list(int)</span>

<span class="sd">        :return: success status.</span>

<span class="sd">        :rtype: bool</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">hid</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>